#include "bhv_mark.h"

#include <rcsc/player/player_agent.h>
#include <rcsc/player/world_model.h>

using namespace rcsc;
Bhv_MarkOpponent::Bhv_MarkOpponent()
{

}

bool Bhv_MarkOpponent::execute( PlayerAgent * agent )
{
    AbstractPlayerCont::const_iterator opp_to_mark = agent->world().opponentsFromSelf().begin();
    bool found_opp_to_mark = false;

    while ( !found_opp_to_mark && opp_to_mark != agent->world().opponentsFromSelf().end() )
    {
        // Am I the closest to this player?
        AbstractPlayerObject* closest_teammate = closestTeammate( *opp_to_mark );
        if ( closest_teammate != NULL && closest_teammate->unum() == agent->world().self() )
        {

        }
    }
}

const rcsc::AbstractPlayerObject* Bhv_MarkOpponent::closestTeammate( const rcsc::AbstractPlayerObject* opponent,
                                                                     const rcsc::WorldModel& world_model )
{
    // TODO This should be pre-calculated in the world-model
    const AbstractPlayerCont& opponents = opponent->side() == world_model.ourSide() ?
                                          world_model.theirPlayers() :
                                          world_model.ourPlayers();

    AbstractPlayerCont::const_iterator it_opp = opponents.begin();
    const AbstractPlayerObject* closest_opp = *it_opp;
    double min_dist = closest_opp->pos().dist(opponent->pos());
    it_opp++;
    while( it_opp != opponents.end() )
    {
        double player_dist = (*it_opp)->pos().dist( opponent->pos() );
        if ( player_dist < min_dist )
        {
            closest_opp = *it_opp;
            min_dist = player_dist;
        }
    }

    return closest_opp;
}
