#ifndef ACTGEN_PASS_OPEN_SPACE_DT_H
#define ACTGEN_PASS_OPEN_SPACE_DT_H

#include "action_generator.h"

class ActGenPassOpenSpaceDT: public ActionGenerator
{
public:
    ActGenPassOpenSpaceDT();

    /*!
      \brief genarate chain of action-state pair
      \param result container variable to store the generated action-state pair
      \param state the last state to generate new action-state pair
      \param wm current world model as the initial state
      \param path chain of action-state pair from the initial state to the last state
     */
    virtual
    void generate( std::vector< ActionStatePair > * result,
                   const PredictState & state,
                   const rcsc::WorldModel & wm,
                   const std::vector< ActionStatePair > & path ) const;
};

#endif // ACTGEN_PASS_OPEN_SPACE_DT_H
