
#include <string>
#include <vector>
#include <map>

class TeamDesc{
 public:
  TeamDesc(unsigned short teamNumber, std::vector<std::string> names, 
	   unsigned char teamQual, unsigned char defenseQual, 
	   unsigned char attackQual, unsigned char playQual, 
	   unsigned char goalieQual);

  inline ~TeamDesc(){}

  static TeamDesc* parse(std::string in, std::string& out);

  inline unsigned short teamNumber() const{return teamNumber_;}
  inline std::vector<std::string> names() const{return names_;}
  inline unsigned char teamQual() const{return teamQual_;}
  inline unsigned char defenseQual() const{return defenseQual_;}
  inline unsigned char attackQual() const{return attackQual_;}
  inline unsigned char playQual() const{return playQual_;}
  inline unsigned char goalieQual() const{return goalieQual_;}

  std::string toString() const;

 private:

  unsigned short teamNumber_;
  std::vector<std::string> names_;
  unsigned char teamQual_;
  unsigned char defenseQual_;
  unsigned char attackQual_;
  unsigned char playQual_;
  unsigned char goalieQual_;
};

class TeamDescContainer{
 public:
  inline TeamDescContainer(){};
  TeamDescContainer(std::map<unsigned short,TeamDesc*> teams):teams_(teams){};
  inline ~TeamDescContainer(){}
  
  static TeamDescContainer* parseFromFile(std::string fileName);

  inline unsigned int numberOfTeams()const{return teams_.size();}

  const TeamDesc* team(unsigned short nbr) const;
  
  
  //returns NULL if there is no match
  TeamDesc* identifyOpponent(std::string name) const;
 private:
  std::map<unsigned short,TeamDesc*> teams_;
};
