#ifndef FCP_AUDIO_CODEC_H
#define FCP_AUDIO_CODEC_H

#include <vector>
#include <string>
#include <rcsc/geom/vector_2d.h>

class FCPAudioCodec
{
private:
    FCPAudioCodec(unsigned int num_chars);
public:

    FCPAudioCodec& instance();

    /// Encode
    std::string long2alphanum();

    void encodePosition(const rcsc::Vector2D& point);
    rcsc::Vector2D decodePosition( );

    void encodePlayerUnum(const unsigned int& unum);
    unsigned int decodePlayerUnum( );

    unsigned int lengthPosition();
    unsigned int lengthPlayerUnum();
    unsigned int lengthConfidence();

    /// Confidence encode/decode
    void encodeConfidence(float value);
    float decodeConfidence();

    /// Decode
    void alphanum2long( char *msg );
    void alphanum2longlong( char *msg );

    void addInfo( unsigned long num_values, long value );
    long getInfo( unsigned long num_values );

    std::string getMessage();

    void reset();
    unsigned int sizeInBits();
    unsigned int sizeInBytes();
private:
    unsigned int bitsNeeded(unsigned int num_values);

    unsigned long long M_info;
    std::vector<unsigned short> M_decode_char;
    unsigned int M_size; /// Size in bits
};

#endif // FCP_AUDIO_CODEC_H
