#include "setplay_abort_message.h"

namespace setplay {

    SetplayAbortMessage::SetplayAbortMessage(const PlayerAffiliation &sender,
                                             unsigned int time,
                                             unsigned int setplay_id, bool inverted)
        : IMessage(sender, time, setplay_id, inverted)
    {

    }

    SetplayAbortMessage::SetplayAbortMessage(const SetplayAbortMessage& other)
        : IMessage(other)
    {

    }

    SetplayAbortMessage::~SetplayAbortMessage()
    {

    }

    MessageType SetplayAbortMessage::type() const
    {
        return MSG_ABORT;
    }

    void SetplayAbortMessage::getProcessed(IMessageProcessor& processor) const
    {
        processor.process( *this );
    }

    SetplayAbortMessage* SetplayAbortMessage::clone() const
    {
        return new SetplayAbortMessage( *this );
    }

    void SetplayAbortMessage::print(std::ostream& os) const
    {
        os << "SetplayAbortMessage" << std::endl;
        IMessage::print( os );
    }
}
