#include "setplay_start_message.h"

using namespace std;

namespace setplay {

    SetplayStartMessage::SetplayStartMessage(const PlayerAffiliation& sender,
                             unsigned int time,
                             unsigned int setplay_id,
                             bool inverted,
                             std::map<std::string, Object*>* arguments)
      : IMessage(sender, time, setplay_id, inverted)
    {

    }

    SetplayStartMessage::SetplayStartMessage(const SetplayStartMessage& other)
      : IMessage(other)
    {

    }


    SetplayStartMessage::~SetplayStartMessage()
    {

    }

    MessageType SetplayStartMessage::type() const
    {
        return MSG_SETPLAY_START;
    }

    void SetplayStartMessage::getProcessed(IMessageProcessor& processor) const
    {
        processor.process( *this );
    }

    SetplayStartMessage* SetplayStartMessage::clone() const
    {
        return new SetplayStartMessage(*this);
    }

    void SetplayStartMessage::print(std::ostream& os) const
    {
        os << "SetplayStartMessage" << std::endl;
        IMessage::print( os );
    }

}
