#ifndef SP_SETPLAY_START_MESSAGE_H
#define SP_SETPLAY_START_MESSAGE_H

#include <setplay/communication/imessage.h>
#include <setplay/model/object.h>

#include <map>
#include <string>

namespace setplay {

    class SetplayStartMessage
            : public IMessage {
    public:
      SetplayStartMessage(const PlayerAffiliation& sender,
                          unsigned int time,
                          unsigned int setplayId,
                          bool inverted = false,
                          std::map<std::string, Object*>* arguments = NULL);
      SetplayStartMessage(const SetplayStartMessage& other);

      virtual ~SetplayStartMessage();

      virtual MessageType type() const;

      void getProcessed(IMessageProcessor& processor) const;

      SetplayStartMessage* clone() const;

      void print(std::ostream& os) const;

    };

}

#endif
