#ifndef IOBSERVABLE
#define IOBSERVABLE

#include <list>
#include <setplay/iobserver.h>

template <class E>
class IObservable {
public:
        virtual ~IObservable() { }

        void registerObserver(IObserver<E>* observer)
        {
            M_observers.push_back(observer);
        }

        void unregisterObserver(IObserver<E>* observer)
        {
            M_observers.remove(observer);
        }

protected:
        void notifyObservers(const E& object)
        {
            for ( typename std::list<IObserver<E>* >::const_iterator it_obs = M_observers.begin();
                  it_obs != M_observers.end();
                  it_obs++)
            {
                (*it_obs)->update( object ); // Should cast this to the event detector type
            }
        }
private:
        std::list<IObserver<E>* > M_observers;
};


#endif
