#include "act_dribble.h"

#include <setplay/model/geom/ilocation.h>
#include <setplay/model/ivisitor.h>

namespace setplay {


    ActDribble::ActDribble(ILocation2D* location)
        : M_location(location)
    {
        assert(location != NULL);
    }

    ActDribble::~ActDribble()
    {
        if ( M_location != NULL) { delete M_location; }
    }


    TokenType ActDribble::type() const
    {
        return TT_ACTION_DRIBBLE;
    }

    IAction::ActionType ActDribble::actionType() const
    {
        return AT_DRIBBLE;
    }

    ILocation2D* ActDribble::location() const
    {
        return M_location;
    }

    ActDribble& ActDribble::setLocation(ILocation2D* location)
    {
        if ( M_location != NULL ) { delete M_location; }
        M_location = location;
        return *this;
    }

    ActDribble& ActDribble::operator*()
    {
        return *this;
    }

    ActDribble* ActDribble::clone() const
    {
        return new ActDribble(*this);
    }

    ActDribble& ActDribble::operator=(const ActDribble& other)
    {
      if (this != &other)
      {
          setLocation( other.M_location != NULL ? other.M_location->clone() : NULL);
      }
      return *this;
    }

    void ActDribble::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }

}
