// -*-c++-*-

/***************************************************************************
                                act_follow.h
                       Abstract base class for CLang IIActions
                             -------------------
    begin                : 28-MAY-2002
    copyright            : (C) 2012 Fernando Almeida
    email                : fernando.almeida@di.estv.ipv.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/
#ifndef SP_ACTION_FOLLOW_H
#define SP_ACTION_FOLLOW_H

#include <setplay/model/actions/act_intercept.h>
#include <setplay/model/geom/ipoint.h>

namespace setplay {

    /// Follow a given object while mainting a given distance
    class ActFollow
            : public ActIntercept {
    public:
    ActFollow(IMobileObject *target = NULL, IPoint2D *displacement = NULL);
    ActFollow(const ActFollow& action);

    ~ActFollow();

    TokenType type() const;
    ActionType actionType() const;

    // Accessors
    IPoint2D *displacement() const;

    ActFollow& setDisplacement(IPoint2D* point);

    ActFollow& operator=(const ActFollow& other);


    ActFollow& operator*();
    ActFollow* clone() const;
    void visit(IVisitor& visitor);

    private:
        IPoint2D* M_displacement;
    };

}

#endif

