// -*-c++-*-

/***************************************************************************
                                   cond_bool.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef SP_COND_BOOL_H_
#define SP_COND_BOOL_H_

#include <setplay/model/conditions/icondition.h>

namespace setplay {

    // Primitive cond, true or false
    class CondBool
            : public ICondition {
        public:

        CondBool( bool M_state );
        CondBool( const CondBool& cond );
        ~CondBool();

        TokenType type() const;

        bool state() const;

        inline CondBool* clone() const
        {
            return new CondBool(*this);
        }

        CondBool& operator*()
        {
            return *this;
        }

        inline CondBool& operator=(const CondBool& other)
        {
          if (this != &other)
          {
              this->M_state = other.M_state;
          }
          return *this;
        }

        void visit(IVisitor& visitor);

    private:
      bool M_state;
    };

}

#endif
