#ifndef COND_CAN_INTERCEPT_H
#define COND_CAN_INTERCEPT_H

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/participants/iplayer.h>

namespace setplay {

/*!
  \brief Check if a player can intercept a mobile object
  */
class CondCanIntercept
        : public ICondition
{
public:
    CondCanIntercept( IPlayer* player = NULL,
                      IMobileObject* mobile_object = NULL);

    CondCanIntercept(const CondCanIntercept& other);
    ~CondCanIntercept();

    TokenType type() const;

    IPlayer* player() const;
    IMobileObject* mobileObject() const;

    CondCanIntercept& setPlayer(IPlayer* player);
    CondCanIntercept& setMobileObject(IMobileObject* mobile_object);

    CondCanIntercept* clone() const;
    CondCanIntercept& operator*();
    void visit(IVisitor &visitor);

private:
    IPlayer* M_player;
    IMobileObject* M_mobile_object;
};

}

#endif // COND_CAN_INTERCEPT_H

