#ifndef COND_CAN_PASS_H
#define COND_CAN_PASS_H

#include <setplay/model/conditions/icondition.h>
#include <setplay/model/participants/iplayer.h>
#include <setplay/model/geom/ilocation.h>

namespace setplay {

class CondCanPass
        : public ICondition
{
public:
    CondCanPass(IPlayer* player = NULL, ILocation2D* location = NULL);
    CondCanPass(const CondCanPass& other);
    ~CondCanPass();

    TokenType type() const;

    IPlayer* player( ) const;
    ILocation2D* location( ) const;

    CondCanPass& setPlayer(IPlayer* player);
    CondCanPass& setLocation(ILocation2D* location);

    CondCanPass* clone() const;
    CondCanPass& operator*();
    void visit(IVisitor& visitor);
private:
    IPlayer* M_player;
    ILocation2D* M_location;
};

}

#endif // COND_CAN_PASS_H
