#include "cond_can_shoot.h"

namespace setplay {

CondCanShoot::CondCanShoot(IPlayer *player)
    : M_player( player )
{

}

CondCanShoot::CondCanShoot(const CondCanShoot& other)
{
    M_player = other.M_player != NULL ? other.M_player->clone() : NULL;
}

CondCanShoot::~CondCanShoot()
{
    if ( M_player != NULL ) { delete M_player; }
}

TokenType CondCanShoot::type() const
{
    return TT_CONDITION_CAN_SHOOT;
}

IPlayer* CondCanShoot::player() const
{
    return M_player;
}

CondCanShoot& CondCanShoot::setPlayer(IPlayer* player)
{
    if ( M_player != NULL ){ delete M_player; }
    M_player = player;
    return *this;
}

CondCanShoot* CondCanShoot::clone() const
{
    return new CondCanShoot( *this );
}

CondCanShoot& CondCanShoot::operator*()
{
    return *this;
}

void CondCanShoot::visit(IVisitor &visitor)
{
    visitor.visit( *this );
}


}
