#include "cond_formation.h"

#include <setplay/model/ivisitor.h>

namespace setplay {

        CondTeamFormation::CondTeamFormation(CondTeamFormation::Formation formation,
                                             TeamAffiliation team_affiliation = TA_OPP)
            : M_formation(formation)
            , M_team_affiliation(team_affiliation)
        {

        }

        CondTeamFormation::CondTeamFormation(const CondTeamFormation& other)
            : M_formation(other.M_formation),
              M_team_affiliation(other.M_team_affiliation)
        {

        }

        CondTeamFormation::~CondTeamFormation()
        {

        }

        TokenType CondTeamFormation::type() const
        {
            return TT_CONDITION_TEAM_FORMATION;
        }

        TeamAffiliation CondTeamFormation::team_affiliation() const
        {
            return M_team_affiliation;
        }

        CondTeamFormation::Formation CondTeamFormation::formation() const
        {
            return M_formation;
        }

        CondTeamFormation* CondTeamFormation::clone() const
        {
            return new CondTeamFormation( *this );
        }

        CondTeamFormation& CondTeamFormation::operator*()
        {
           return *this;
        }

        CondTeamFormation& CondTeamFormation::operator=(const CondTeamFormation& other)
        {
            if (this != &other)
            {
                this->M_formation = other.M_formation;
                this->M_team_affiliation = other.M_team_affiliation;
            }
            return *this;
        }

        void CondTeamFormation::visit(IVisitor& visitor)
        {
            visitor.visit( *this );
        }

}
