#include "cond_not.h"

#include <setplay/model/ivisitor.h>


namespace setplay {
    CondNot::CondNot(ICondition *cond)
        : M_condition(cond)
    {

    }

    CondNot::CondNot(const CondNot& other)
    {
        M_condition = other.M_condition != NULL
                        ? other.M_condition->clone()
                        : NULL;
    }

    CondNot::~CondNot()
    {
        if ( M_condition !=NULL ) { delete M_condition; }
    }

    TokenType CondNot::type() const
    {
        return TT_CONDITION_NOT;
    }

    ICondition*
    CondNot::condition() const { return M_condition; }

    void CondNot::setCondition(ICondition* condition)
    {
        if ( M_condition != NULL ) { delete M_condition; }
        M_condition = condition;
    }

    CondNot& CondNot::operator=(const CondNot& other)
    {
        if (this != &other)
        {
            setCondition( other.M_condition->clone() );
        }
        return *this;
    }

    CondNot* CondNot::clone() const
    {
        return new CondNot(*this);
    }

    CondNot& CondNot::operator*()
    {
        return *this;
    }

    void CondNot::visit(IVisitor& visitor)
    {
        visitor.visit( *this );
    }
}
