// -*-c++-*-

/***************************************************************************
                                   cond_or.h
                               Clang conditions
                             -------------------
    begin                : 28-NOV-2006
    copyright            : (C) 2006 by Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                       *
 *                                                                         *
 ***************************************************************************/

#ifndef COND_OR_H_
#define COND_OR_H_

#include <setplay/model/conditions/icondition.h>

namespace setplay {

        // Composite condition: logical or
            class CondOr
                    : public ICondition
            {
            public:
              CondOr(Conditions* conditions = NULL);
              CondOr(const CondOr& other);
	      ~CondOr();

              Conditions* conditions() const;

              TokenType type() const;

              CondOr& operator=(const CondOr& other);

              void push(ICondition* cond);
              void push(Conditions* conditions);


              void visit(IVisitor& visitor);
              CondOr* clone() const;
              CondOr& operator*();

            private:
              Conditions* M_conditions;
            };

}

#endif
