// -*-c++-*-

#ifndef SP_DIRECTIVE_H
#define SP_DIRECTIVE_H

#include <setplay/model/participants/iplayer.h>
#include <setplay/model/actions/iaction.h>
#include <setplay/model/object.h>

#include <cassert>
#include <vector>

using namespace std;

namespace setplay {

        class IDirective
            : public Object {
        public:
          typedef enum
          {
            DT_DO,
            DT_DONT,
            DT_DO_WHILE
          } DirectiveType;

          IDirective(Players* players = NULL, Actions* actions = NULL);
          IDirective(const IDirective& other);
          virtual ~IDirective();

          Players* players() const;
          Actions* actions() const;

          bool hasActions() const;
          bool hasPlayers() const;

          virtual DirectiveType directiveType() const = 0;

          IDirective& addAction( IAction* action );
          IDirective& addPlayer( IPlayer* players );
          IDirective& setPlayers( Players* players );
          IDirective& setActions( Actions* actions );

          virtual IDirective* clone() const = 0;
        protected:
          Players* M_players;
          Actions *M_actions;
        };

}
#endif
