#ifndef SP_REG_CIRCLE_H
#define SP_REG_CIRCLE_H

#include <setplay/model/geom/iregion.h>
#include <setplay/model/geom/ipoint.h>
#include <setplay/model/numbers/number_var.h>


namespace setplay {

    class Circle2D : public IRegion2D {
        //Angle should be in range -180..180, angle span 0..360
    public:

      Circle2D( IPoint2D* center, IDecimal* radius);
      Circle2D( const Circle2D& other);
      virtual ~Circle2D();

      inline TokenType type() const
      {
          static TokenType type = TT_CIRCLE;
          return type;
      }

      /// Accessors
      IPoint2D* center( ) const;
      IDecimal* radius( ) const;

      Circle2D& setCenter(IPoint2D* point);
      Circle2D& setRadius(IDecimal* decimal);

      Circle2D& operator*();
      Circle2D* clone() const;
      void visit(IVisitor& visitor);
    private:
      /* start rad <= end_rad */
      IPoint2D* M_center;
      IDecimal* M_radius;
    };

}

#endif
