#ifndef SP_TRIANGLE_2D_H
#define SP_TRIANGLE_2D_H

#include <setplay/model/geom/iregion.h>
#include <setplay/model/geom/ipoint.h>

namespace setplay {

    class Triangle2D
	: public IRegion2D {
    public:
      Triangle2D(IPoint2D* a = NULL, IPoint2D* b = NULL, IPoint2D* c = NULL);
      Triangle2D(const Triangle2D& other);
      ~Triangle2D();

      TokenType type() const;

      IPoint2D* a() const;
      IPoint2D* b() const;
      IPoint2D* c() const;

      Triangle2D& setA(IPoint2D* point);
      Triangle2D& setB(IPoint2D* point);
      Triangle2D& setC(IPoint2D* point);

      Triangle2D& operator=(const Triangle2D& other);

      Triangle2D& operator*();
      Triangle2D* clone() const;
      void visit(IVisitor& visitor);
    private:
      IPoint2D* M_a;
      IPoint2D* M_b;
      IPoint2D* M_c;
    };

}
#endif
