// -*-c++-*-
#ifndef SP_IPARTICIPATION_H
#define SP_IPARTICIPATION_H

#include <vector>

#include <setplay/model/participants/iplayer.h>
#include <setplay/model/geom/ilocation.h>

using namespace std;

namespace setplay {

    class IParticipation
        : public Object {
    public:
      IParticipation(IPlayer* player = NULL,
                     ILocation2D* location = NULL);
      IParticipation(const IParticipation& other);
      virtual ~IParticipation();

      //Inspectors
      IPlayer* player() const;
      ILocation2D* location() const;
      bool hasLocation() const;

      IParticipation& setLocation(ILocation2D* location);
      IParticipation& setPlayer(IPlayer* player);

      IParticipation& operator=(const IParticipation& other);

      /// Overriden methods
      TokenType type() const;
      IParticipation* clone() const;
      void visit(IVisitor& visitor);

    private:
      IPlayer* M_player;
      ILocation2D* M_location;
    };

    /*!
      \brief Compare participations in order to sort them from by number o
      ascendently by number of dependencies
      */
    struct ParticipationCmp
            : public binary_function<IParticipation*,
                                     IParticipation*,
                                     bool>
    {
    public:
        ParticipationCmp();

        bool operator() (IParticipation* p1,
                         IParticipation* p2);
    };
}

#endif
