#ifndef IPLAYER_H
#define IPLAYER_H

#include <setplay/model/object.h>

namespace setplay {

    class IPlayer
        : public IMobileObject {
    public:
        typedef enum
        {
            PT_PlayerAffiliation,
            PT_PlayerVar,
            PT_PlayerSelf,
            PT_NearestPlayer,
            PT_NearestTeammate,
            PT_NearestOpponent,
            PT_Goalie
        } PlayerType ;

        virtual ~IPlayer() { }

        MobileObjectType mobileObjectType() const
        {
            return MOT_PLAYER;
        }

        virtual PlayerType playerType() const = 0;

        virtual IPlayer* clone() const = 0;
    };

    typedef std::vector<IPlayer*> Players;

}


#endif // IPLAYER_H
