// -*-c++-*-

/***************************************************************************
                                IActionEvaluator.h
                       Abstract base class for CLang Actions
                             -------------------
    begin                : 28-MAY-2002
    copyright            : (C) 2006 Luis Mota
    email                : luis.mota@iscte.pt
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU LGPL as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option) any  *
 *   later version.                                                        *
 *                                                                         *
 ***************************************************************************/
#ifndef SP_ACTION_EVALUATOR_H
#define SP_ACTION_EVALUATOR_H

namespace setplay
{
     class ActPos;
     class ActPass;
     class ActDribble;
     class ActShoot;
     class ActHold;
     class ActIntercept;
     class ActFollow;

     class IActionEvaluator {
        public:
            virtual ~IActionEvaluator() { }

            virtual bool canExecute( const ActPos& action ) = 0;
            virtual bool canExecute( const ActPass& action ) = 0;
            virtual bool canExecute( const ActDribble& action )  = 0;
            virtual bool canExecute( const ActShoot& action )  = 0;
            virtual bool canExecute( const ActHold& action )  = 0;

            virtual bool canExecute( const ActIntercept& action )  = 0;

            //2010
            // virtual void canExecute( const ActMoveToLineX& action )  = 0;

            //2012
            virtual bool canExecute( const ActFollow& action )  = 0;
    };
}

#endif // END ACTION_EVALUATOR_H
