#ifndef SETPLAY_STATE_UPDATE_DECIDER_H
#define SETPLAY_STATE_UPDATE_DECIDER_H

namespace setplay {

class SetplayInterpreter;

class IStateUpdateDecider
{
public:
    virtual ~IStateUpdateDecider() { }

    virtual bool canUpdateInterpreterState(const SetplayInterpreter& interpreter) = 0;

};

class AnyParticipantStateUpdater
        : public IStateUpdateDecider
{
    bool canUpdateInterpreterState(const SetplayInterpreter& interpreter);
};


class LeaderStateUpdater
        : public IStateUpdateDecider
{
    bool canUpdateInterpreterState(const SetplayInterpreter& interpreter);
};

}

#endif
