#include <setplay/model/setplay.h>
#include <setplay/region.h>
#include <setplay/namesubstitutions.h>
#include <setplay/clang/vector.h>
#include <setplay/context.h>

#include <fstream>


using namespace std;
using namespace rcss::geom;
using namespace fcportugal::setplay;

int main(int argc,char *argv[]){
  if(argc!=2) {
    cout<<"Usage: "<<argv[0]<<" file_name"<<endl;
    return 0;
  }

  vector<string> text;
  string line;
  ifstream textstream (argv[1]);
  while (getline(textstream, line)) {
    text.push_back(line);
  } 
  textstream.close();
  string alltext;
  for (unsigned int i=0; i < text.size(); i++){
    size_t j = text[i].find('\t', 0);
    while(j!=string::npos){
      text[i].replace(j,1," ");
      j = text[i].find("\t", 0);
    }
    alltext += text[i];
  } 
 

  string resto;
  Setplay* sp = Setplay::parse(alltext,resto,false,false,NULL,0);
    
  while (sp) {
      cout<<"\n\n\n\n################ SETPLAY ##############\n\n\n\n";
      
      cout<<"Original:\n";
      if(sp) {
        cout<<"\n\nPretty version\n\n";
        sp->write2(cout,1);
      }else{
        cout<<"SP a NULL"<<endl;
        exit(0);
      }
      cout<<"\n\n___________\n\n";

      Setplay* sp2 = sp->clone();
      cout<<"\nCopia:\n";
      sp2->write2(cout,1);
      cout<<"\n\n\n\n_______________________\n\n\n\n";


      // TODO Fix context!!!
      SoccerContextSim2D *context = new SoccerContextSim2D();

      if (sp->isInvertable()) {
          Setplay* sp3 = sp->inversion(context);
          cout<<"\nInversao:\n";
          sp3->write2(cout,1);
          cout<<"\n\n\n\n_______________________\n\n\n\n";
      }

      sp=Setplay::parse(resto,resto,false,false,NULL, 0);
  }



}
