#include <iostream>
#include <setplay/generators/sexpr/setplay_generator_sexpr.h>
#include <setplay/parsers/sexpr/setplay_parser_sexpr_driver.h>
#include <algorithm>

#include <setplay/model/iparticipation.h>
#include <setplay/runtime/setplay_augmenter.h>

#include <list>

using namespace setplay;
using namespace setplay::parsers;

int main (int argc, char *argv[])
{
    SetplayParserSexprDriver driver(true, true);
    ParticipationCmp participation_cmp;

    std::list<ISetplayAugmenter*> augmenters;
    augmenters.push_back( new StepWaitConditionAugmenter() );
    for (int i = 1; i < argc; ++i)
    {
        if ( driver.parseFile(argv[i]) )
        {
                std::cout << "successful" << std::endl;
                    std::ofstream os("out.txt");
                    SetplayGeneratorSexpr sexpr(os);
                std::cout << "Parsed " << driver.setplays().size() << " setplays" << std::endl;
            for (vector<Setplay*>::iterator it = driver.setplays().begin() ;
                 it != driver.setplays().end(); it++)
            {
                for (list<ISetplayAugmenter*>::iterator ita = augmenters.begin(); ita != augmenters.end(); ita++ )
                {
                    if ( (*ita)->augment(*it) )
                    {
                        std::cout << "Setplay " << (*it)->id() << " augmented " << std::endl;
                        for ( Steps::const_iterator its = (*it)->steps()->begin(); its != (*it)->steps()->end() ; its++ )
                        {
                            if ( (*its).second->hasWaitCondition() )
                            {
                                (*its).second->waitCondition()->visit( SetplayGeneratorSexprLog );
                                std::clog << std::endl;
                            }
                            else
                            {
                                std::clog << " Step " << (*its).first << " has not wait conditions !!!!" << std::endl;
                            }
                        }
                    }
                }
                std::cout << "Participations: " << (*it)->firstStep()->participations()->size() << std::endl;
                    sort( (*it)->firstStep()->participations()->begin(),
                      (*it)->firstStep()->participations()->end(),
                      participation_cmp );
                (*it)->visit( sexpr );
                std::cout << "Delete setplay " << (*it)->id() << std::endl;
                delete *it;
            }
            os.close();
        }
    }
}
