#ifndef BALL_DISPUTE_H
#define BALL_DISPUTE_H

#include <soccer/events/event.h>
#include <soccer/player_id.h>

#include <vector>

namespace soccer {
    namespace event {

    class BallDispute
            : public Event
    {
    public:
        BallDispute(unsigned int start_time);
        BallDispute(unsigned int start_time,
                    unsigned int end_time,
                    std::vector<PlayerId> players);

        EventType type() const;
        const std::vector<PlayerId>& players() const;

        void addPlayer(PlayerId player);

        void visit(IEventVisitor& visitor) const;
    private:
        std::vector<PlayerId> M_kickers;
    };

    }
}

#endif
