#include "ball_move.h"
#include "ievent_visitor.h"

using namespace rcsc;

namespace soccer
{
	namespace event
	{
		
        BallMove::BallMove(unsigned int start_time, unsigned int end_time)
			: Event(start_time, end_time)
		{
		
		}
					   		
        IEvent::EventType BallMove::type() const
        {
            return IEvent::BallMove;
        }

		Vector2D BallMove::from() const
		{
			return M_from;
		}
		
		Vector2D BallMove::to() const
		{
			return M_to;
		}
		
        void BallMove::visit(IEventVisitor& visitor) const
		{
			visitor.visit( *this );
		}
			
        BallMove& BallMove::setTo(rcsc::Vector2D to)
        {
            M_to = to;
            return *this;
        }

        BallMove& BallMove::setFrom(rcsc::Vector2D from)
        {
            M_from = from;
            return *this;
        }

	}
}
