#include "dribble.h"
#include "ievent_visitor.h"

using namespace rcsc;

namespace soccer 
{
	namespace event 
	{

		Dribble::Dribble(unsigned int start_time, unsigned int end_time,
						PlayerId dribbler)
			: Event(start_time, end_time)
			, M_dribbler(dribbler)
		{
		
		}

        IEvent::EventType Dribble::type() const
        {
            return IEvent::Dribble;
        }

		PlayerId Dribble::dribbler() const
		{
			return M_dribbler;
		}
		
        void Dribble::visit(IEventVisitor& visitor) const
		{
			visitor.visit( *this );
		}

	}
}
