#ifndef EVENT_CHAIN_H
#define EVENT_CHAIN_H

#include <tr1/memory>
#include <vector>
#include <soccer/events/ievent.h>

namespace soccer {
namespace event {

class EventChain
        : public IEvent
        , public std::vector< std::tr1::shared_ptr<IEvent> >
{
public:
    EventChain();
    EventChain( const std::vector< std::tr1::shared_ptr<IEvent> >& events);
    EventChain( const EventChain& event_chain );

    /*!
      \brief Determine the number of events of a given type
      \param Type of event to count
      */
    unsigned int numEvents(EventType type);

    // Override interface methods
    unsigned int startTime() const;
    unsigned int endTime() const;
};

}
}

#endif // EVENT_CHAIN_H
