#include "event_participants.h"

using namespace std;
using namespace std::tr1;

namespace soccer {
namespace event {

PlayersInEventsExtractor::PlayersInEventsExtractor()
{

}

const map<PlayerId, vector< const IEvent* > >& PlayersInEventsExtractor::playerEvents() const
{
    return M_player_events;
}

const vector<PlayerId >& PlayersInEventsExtractor::players() const
{
    return M_players;
}

void PlayersInEventsExtractor::visit(const KickOff& event)
{

}

void PlayersInEventsExtractor::visit(const KickOffTaken& event)
{
    // addParticipant( PlayerId( event.taker() ), event );
}

void PlayersInEventsExtractor::visit(const ThrowIn& event)
{

}

void PlayersInEventsExtractor::visit(const ThrowInTaken& event)
{
    // addParticipant( PlayerId( event.taker() ), event );
}

void PlayersInEventsExtractor::visit(const GoalKick& event)
{

}

void PlayersInEventsExtractor::visit(const GoalKickTaken& event)
{
    // addParticipant( PlayerId( event.taker() ), event );
}

void PlayersInEventsExtractor::visit(const CornerKick& event)
{

}

void PlayersInEventsExtractor::visit(const CornerKickTaken& event)
{
    // addParticipant( PlayerId( event.taker() ), event );
}

void PlayersInEventsExtractor::visit(const FreeKick& event)
{

}

void PlayersInEventsExtractor::visit(const FreeKickTaken& event)
{
    // addParticipant( PlayerId( event.taker() ), event );
}

void PlayersInEventsExtractor::visit(const IndirectFreeKick& event)
{

}

void PlayersInEventsExtractor::visit(const IndirectFreeKickTaken& event)
{
    // addParticipant( PlayerId( event.taker() ), event );
}

void PlayersInEventsExtractor::visit(const Goal& event)
{

}

void PlayersInEventsExtractor::visit(const SoccerMomentChanged& event)
{

}

void PlayersInEventsExtractor::visit(const PossessionChanged& event)
{

}

void PlayersInEventsExtractor::visit(const Shoot& event)
{
    addParticipant( PlayerId( event.shooter() ), event );
}

void PlayersInEventsExtractor::visit(const Dribble& event)
{
    addParticipant( PlayerId( event.dribbler() ), event );
}

void PlayersInEventsExtractor::visit(const Pass& event)
{
    addParticipant( PlayerId( event.sender(), event.teamSide() ), event );
    addParticipant( PlayerId( event.receiver(), event.teamSide() ), event );
}

void PlayersInEventsExtractor::visit(const Interception& event)
{
    addParticipant( event.interceptor(), event );
}

void PlayersInEventsExtractor::visit(const Turnover& event)
{

}

void PlayersInEventsExtractor::visit(const PlayerMove& event)
{
    addParticipant( event.player(), event );
}


void PlayersInEventsExtractor::visit(const GoalieCatch& event)
{
    /// TODO Develop a way to abstract a goalie?
}

void PlayersInEventsExtractor::visit(const BallKick& event)
{
    addParticipant( event.kicker(), event );
}

void PlayersInEventsExtractor::visit(const BallDispute& event)
{

}

void PlayersInEventsExtractor::visit(const BallMove& event)
{

}

void PlayersInEventsExtractor::visit(const BallHold& event)
{
    addParticipant( event.holder(), event );
}

void PlayersInEventsExtractor::visit(const Offside& event)
{
    // addParticipant( event. );
}


void PlayersInEventsExtractor::visit(const PassChain& event)
{
    addParticipants(event);
}

void PlayersInEventsExtractor::visit(const GoalPassChain& event)
{
    addParticipants(event);
}

void PlayersInEventsExtractor::addParticipants( const EventChain& event )
{
    for( vector< shared_ptr<IEvent> >::const_iterator ite = event.begin();
         ite != event.end(); ite++ )
    {
        (*ite)->visit( *this );
    }
}

void PlayersInEventsExtractor::addParticipant( soccer::PlayerId player_id, const IEvent& event )
{
    map<soccer::PlayerId, vector< const IEvent*> >::iterator itp = M_player_events.find(player_id);

    if ( itp == M_player_events.end() )
    {
        // Not adding duplicate players
        vector< const IEvent* > events;
        events.push_back( &event );
        M_players.push_back( player_id );
        M_player_events.insert(pair<PlayerId, vector< const IEvent*> >( player_id, events ));
        return;
    }

    itp->second.push_back( &event );
}


}
}
