#include "goal.h"
#include "ievent_visitor.h"

namespace soccer
{
	namespace event
	{
		
        Goal::Goal(unsigned int time, TeamSide side)
			: Event(time)
            , M_side(side)
		{
		
		}

        Goal::Goal(const Goal& other)
            : Event(other)
            , M_side(other.M_side)
        {

        }


        IEvent::EventType Goal::type() const
        {
            return IEvent::Goal;
        }

        TeamSide Goal::side() const
		{
            return M_side;
		}
		
        void Goal::visit(IEventVisitor& visitor) const
		{
			visitor.visit( *this );
		}
		
	}
}
