#include "goal_kick_taken.h"
#include "ievent_visitor.h"

namespace soccer
{
    namespace event
    {

        GoalKickTaken::GoalKickTaken(unsigned int start_time, TeamSide side)
            : Event(start_time)
            , M_side(side)
        {

        }

        IEvent::EventType GoalKickTaken::type() const
        {
            return IEvent::GoalKickTaken;
        }

        TeamSide GoalKickTaken::side() const
        {
            return M_side;
        }

        void GoalKickTaken::visit(IEventVisitor& visitor) const
        {
            visitor.visit( *this );
        }

    }
}
