#include "interception.h"

#include "ievent_visitor.h"

namespace soccer {
namespace event {


Interception::Interception(unsigned int start_time, PlayerId interceptor)
    : Event(start_time)
    , M_interceptor(interceptor)
{

}

IEvent::EventType Interception::type() const
{
    return IEvent::Interception;
}

PlayerId Interception::interceptor() const
{
    return M_interceptor;
}

void Interception::visit(IEventVisitor& visitor) const
{
    visitor.visit( *this );
}

}
}
