#ifndef OFFSIDE_H
#define OFFSIDE_H

#include <vector>
#include <soccer/events/event.h>
#include <soccer/player_id.h>

namespace soccer
{
	namespace event
	{
		
		class Offside: public Event {
		public:
            Offside(unsigned int start_time, TeamSide side);

            void addPlayer( unsigned int number );
            EventType type() const;
            TeamSide side() const;
            const std::vector<unsigned int>& players() const;

            void visit(IEventVisitor& visitor) const;
		private:
            TeamSide M_side;
            std::vector<unsigned int> M_players;
		};
	
	}
}

#endif
