#include "pass.h"
#include "ievent_visitor.h"

namespace soccer
{
	namespace event
	{
		
		Pass::Pass(unsigned int start_time, unsigned int end_time, 
               TeamSide team_side, Unum sender, Unum receiver)
            : Event( start_time, end_time )
            , M_team_side( team_side )
            , M_sender( sender )
            , M_receiver( receiver )
		{
		
		}

        IEvent::EventType Pass::type() const
        {
            return IEvent::Pass;
        }

        TeamSide Pass::teamSide() const
        {
            return M_team_side;
        }
			
        soccer::Unum Pass::sender() const
		{
			return M_sender;
		}
		
        soccer::Unum Pass::receiver() const
		{
			return M_receiver;
		}
		
        void Pass::visit(IEventVisitor& visitor) const
		{
			visitor.visit( *this );
		}
		
	}
}
