#include "pass_chain.h"
#include "ievent_visitor.h"

namespace soccer
{
	namespace event
	{
	
        PassChain::PassChain()
		{

		}

        PassChain::PassChain( const std::vector< std::tr1::shared_ptr<IEvent> >& events)
            : EventChain(events)
        {

        }

        PassChain::PassChain(const PassChain& pass_chain)
            : EventChain(pass_chain)
        {

        }

        IEvent::EventType PassChain::type() const
        {
            return IEvent::PassChain;
        }
			
        void PassChain::visit(IEventVisitor& visitor) const
		{
			visitor.visit( *this );
		}
			
	}
}
