#include "player_move.h"
#include "ievent_visitor.h"

namespace soccer
{
	namespace event
	{
		
		PlayerMove::PlayerMove(unsigned int start_time, unsigned int end_time,
                               PlayerId player)
			: Event(start_time, end_time)
			, M_player(player)
		{
		
		}

        IEvent::EventType PlayerMove::type() const
        {
            return IEvent::PlayerMove;
        }

		PlayerId PlayerMove::player() const
		{
			return M_player;
		}
		
		rcsc::Vector2D PlayerMove::from() const
		{
			return M_from;
		}
		
		rcsc::Vector2D PlayerMove::to() const
		{
			return M_to;
		}
		
        PlayerMove& PlayerMove::setTo(rcsc::Vector2D to)
        {
            M_to = to;
            return *this;
        }

        PlayerMove& PlayerMove::setFrom(rcsc::Vector2D from)
        {
            M_from = from;
            return *this;
        }

        void PlayerMove::visit(IEventVisitor& visitor) const
		{
			visitor.visit( *this );
		}
			
	}
}
