#ifndef PLAYER_MOVE_H
#define PLAYER_MOVE_H

#include <soccer/events/event.h>
#include <soccer/player_id.h>
#include <rcsc/geom/vector_2d.h>

namespace soccer
{
	namespace event
	{
		
		class PlayerMove: public Event {
		public:
			PlayerMove(unsigned int start_time, unsigned int end_time,
					   PlayerId player);

            EventType type() const;
			PlayerId player() const;
			rcsc::Vector2D from() const;
			rcsc::Vector2D to() const;

            PlayerMove& setTo(rcsc::Vector2D to);
            PlayerMove& setFrom(rcsc::Vector2D from);
			
            void visit(IEventVisitor& visitor) const;
		private:
			rcsc::Vector2D M_from;
			rcsc::Vector2D M_to;
			PlayerId M_player;
		
		};
	
	}
}

#endif
