#include "possession_changed.h"

#include <soccer/events/ievent_visitor.h>

namespace soccer {
namespace event {

PossessionChanged::PossessionChanged(unsigned int start_time, TeamSide team_in_possession)
    : Event(start_time)
    , M_team_in_possession( team_in_possession )
{

}

IEvent::EventType PossessionChanged::type() const
{
    return IEvent::PossessionChanged;
}

TeamSide PossessionChanged::teamInPossession() const
{
    return M_team_in_possession;
}

void PossessionChanged::visit(IEventVisitor &visitor) const
{
    visitor.visit( *this );
}

}
}
