#ifndef IMOVING_OBJECT_H
#define IMOVING_OBJECT_H

#include "istatic_object.h"

namespace soccer {

class IMovingObject
        : public IStaticObject  {
public:
        IMovingObject(rcsc::Vector2D position, rcsc::Vector2D velocity)
            : IStaticObject(position)
            , M_velocity(velocity)
        {

        }

        IMovingObject(rcsc::Vector2D position)
            : IStaticObject(position)
            , M_velocity(rcsc::Vector2D(0.0,0.0))
        {

        }

        IMovingObject(const IMovingObject& other)
            : IStaticObject(other)
            , M_velocity(other.velocity())
        {

        }

	virtual ~IMovingObject() { }

        virtual rcsc::Vector2D velocity() const
        {
            return M_velocity;
        }

private:
    rcsc::Vector2D M_velocity;
		
};

}

#endif

