#ifndef IPLAYER_H
#define IPLAYER_H

#include "imoving_object.h"
#include "iplayer_id.h"

namespace soccer {

class IPlayer
    : public IPlayer
    , public IMovingObject {

    virtual ~IPlayer() { }

    rcsc::AngleDeg bodyDirection() const = 0;
    rcsc::AngleDeg neckDirection() const = 0;

    // Stamina Model
    double stamina() const = 0;
    double effort() const = 0;
    double recovery() const = 0;
    double capacity() const = 0;

    int timeToReachPosition(const rcsc::Vector2D& target_position) const = 0;
    int timeToReachMaxSpeed( ) const = 0;

};

}

#endif
