#ifndef ISCENE_H
#define ISCENE_H

#include <vector>


#include <soccer/types.h>
#include <soccer/player_id.h>

#include <soccer/player.h>
#include <soccer/ball.h>

namespace soccer
{
    class IScene
    {
    public:
        virtual ~IScene() { }


        virtual float ballX() const = 0;
        virtual float ballY() const = 0;

        virtual float playerX( TeamSide side,
                               unsigned int number) const = 0;
        virtual float playerY( TeamSide side,
                               unsigned int number) const = 0;

        virtual bool isGoalie( TeamSide side,
                               unsigned int number ) const = 0;

        inline rcsc::Vector2D playerPosition( const PlayerId& player_id ) const
        {
            return rcsc::Vector2D( playerX( player_id.side(), player_id.number()),
                                   playerY( player_id.side(), player_id.number()));
        }

        inline rcsc::Vector2D ballPosition( ) const
        {
            return rcsc::Vector2D( ballX(), ballY() );
        }
    };
}

#endif
