#ifndef PLAYER_AFFILIATION_H
#define PLAYER_AFFILIATION_H

#include <soccer/types.h>

namespace soccer {

class PlayerAffiliation
{
public:
    PlayerAffiliation(unsigned int number, TeamAffiliation affiliation);
    PlayerAffiliation(const PlayerAffiliation& other);

    // Override interface methods
    unsigned int number() const;
    TeamAffiliation affiliation() const;

    // Operator overload
    PlayerAffiliation& operator=(const PlayerAffiliation& other);
    bool operator==(const PlayerAffiliation& other) const;
    bool operator!=(const PlayerAffiliation& other) const;

    bool operator<(const PlayerAffiliation& other) const;
    bool operator>(const PlayerAffiliation& other) const;

private:
    unsigned int M_number;
    TeamAffiliation M_affiliation;
};

}

#endif // PLAYER_AFFILIATION_H
