#include <soccer/player_id.h>


namespace soccer
{

    PlayerId::PlayerId(Unum number, TeamSide side, bool goalie)
        : M_number( number )
        , M_side( side )
        , M_goalie( goalie )
    {

    }

    PlayerId::PlayerId(const PlayerId& other)
        : M_number( other.M_number )
        , M_side( other.M_side )
        , M_goalie( other.M_goalie )
    {

    }

    Unum PlayerId::number() const
    {
        return M_number;
    }

    TeamSide PlayerId::side() const
    {
        return M_side;
    }

    bool PlayerId::isGoalie() const
    {
        return  M_goalie;
    }


    PlayerId& PlayerId::operator=(const PlayerId& other)
    {
        if ( this == &other )
        {
            this->M_number = other.M_number;
            this->M_side = other.M_side;
        }

        return *this;
    }

    bool PlayerId::operator==(const PlayerId& other) const
    {
        return side() == other.side() && M_number == other.M_number;
    }

    bool PlayerId::operator!=(const PlayerId& other) const
    {
        return !(*this == other);
    }

    bool PlayerId::operator<(const PlayerId& other) const
    {
        if ( M_side != other.M_side )
        {
            return M_side == TS_LEFT ? true : false;
        }

        return this->M_number < other.M_number;
    }

    bool PlayerId::operator>(const PlayerId& other) const
    {
        return ! (*this < other);
    }
}
