#ifndef ISCENE_PLAYER_H
#define ISCENE_PLAYER_H

#include <soccer/iscene.h>

namespace soccer {

    class IScenePlayer {
	public:
        virtual ~IScenePlayer() { }

        /*!
          \brief Get the scene at the specified time
          \param index The time at which the scene occured
          \returns A pointer to the scene descriptor or NULL otherwise
          */
        virtual const IScene* getScene(unsigned int time) = 0;

        virtual float playerTravelledDistance( const soccer::PlayerId& player_id,
                                               unsigned int start_time,
                                               unsigned int end_time ) = 0;
	};

}

#endif
