#ifndef FCPORTUGAL_STRATEGY_FLUX_CONFIG_H
#define FCPORTUGAL_STRATEGY_FLUX_CONFIG_H

#include <strategy/options_config.h>

namespace soccer
{
    namespace strategy
    {

        class FluxConfig
                : public OptionsConfig<FluxConfig>
        {
            friend class Singleton<FluxConfig>;
        public:
            // Fluxes configurations
            bool useFluxes() const;
            const std::string& fluxesDir() const;
            const std::vector<std::string>& fluxFiles() const;
            int defaultFluxId() const;

            void print(std::ostream& os) const;
        private:
            FluxConfig();

            // Fluxes configuration
            static const bool USE_FLUXES;
            static const std::string FLUXES_DIR;
            static const int DEFAULT_FLUX_ID;

            bool M_use_fluxes;
            std::string M_fluxes_dir;
            std::vector<std::string> M_flux_files;
            /// Identifier of the flux to be used by default
            int M_default_flux_id;
        };

    }
}
#endif // FCPORTUGAL_STRATEGY_FLUX_CONFIG_H
