#include "formation.h"

#include <sstream>

#include <strategy/util.h>

#include <league_config.h>

using namespace soccer::strategy;
using namespace soccer;

namespace soccer
{
    namespace formation
    {

        Formation::Formation(unsigned int id)
            : M_player_types()
            , M_id(id)
        {

        }

        Formation::~Formation()
        {

        }


        unsigned int Formation::playerType( const Unum& number) const
        {
            return M_player_types.at(number);
        }


        const typename Formation::PlayerTypes&
        Formation::playerTypes() const
        {
            return M_player_types;
        }


        unsigned int Formation::id() const
        {
            return M_id;
        }


        bool Formation::readPlayerTypes(std::istream& is)
        {
            std::istringstream istr(util::getNextLine(is));
            // Read as many player types as there are players per team in the league
            // TODO MUST READ THE NUMBER OF PLAYERS IN THE FORMATION
            int num_players = -1;
            istr >> num_players;
            assert ( num_players > 0 );
            for ( unsigned int unum = 1; unum <= (unsigned int) num_players; unum++)
            {
                int player_type_id = -1;
                istr >> player_type_id;
                M_player_types[unum] = player_type_id;
            }

            return true;
        }


        std::ostream& Formation::print(std::ostream &os) const
        {
            os << "Formation " << M_id << std::endl;
            return printPlayerTypes(os);
        }


        std::ostream& Formation::printPlayerTypes(std::ostream &os) const
        {
            // Show player types
            os << "Player types " << std::endl;
            for ( typename PlayerTypes::const_iterator itpt = M_player_types.begin();
                 itpt != M_player_types.end();
                 itpt++)
            {
                os << "PlayerType: i" << itpt->first << " " << itpt->second << " ";
            }
            os << std::endl;
            return os;
        }


    }
}
