#include "formation_fcp_dt_2d.h"

#include <rcsc/formation/formation.h>

using namespace rcsc;
using namespace rcsc::formation;

namespace soccer
{
    namespace formation
    {

	void
	FormationDT2D::createDefaultData( )
	{
		SampleData data;

		createNewRole( 1, "Goalie", rcsc::Formation::CENTER );
		createNewRole( 2, "CenterBack", rcsc::Formation::SIDE );
		setSymmetryType( 3, 2, "CenterBack" );
		createNewRole( 4, "SideBack", rcsc::Formation::SIDE );
		setSymmetryType( 5, 4, "SideBack" );
		createNewRole( 6, "DefensiveHalf", rcsc::Formation::CENTER );
		createNewRole( 7, "OffensiveHalf", rcsc::Formation::SIDE );
		setSymmetryType( 8, 7, "OffensiveHalf" );
		createNewRole( 9, "SideForward", rcsc::Formation::SIDE );
		setSymmetryType( 10, 9, "SideForward" );
		createNewRole( 11, "CenterForward", rcsc::Formation::CENTER );

		data.ball_.assign( 0.0, 0.0 );
		data.players_.push_back( Vector2D( -50.0, 0.0 ) );
		data.players_.push_back( Vector2D( -20.0, -8.0 ) );
		data.players_.push_back( Vector2D( -20.0, 8.0 ) );
		data.players_.push_back( Vector2D( -18.0, -18.0 ) );
		data.players_.push_back( Vector2D( -18.0, 18.0 ) );
		data.players_.push_back( Vector2D( -15.0, 0.0 ) );
		data.players_.push_back( Vector2D( 0.0, -12.0 ) );
		data.players_.push_back( Vector2D( 0.0, 12.0 ) );
		data.players_.push_back( Vector2D( 10.0, -22.0 ) );
		data.players_.push_back( Vector2D( 10.0, 22.0 ) );
		data.players_.push_back( Vector2D( 10.0, 0.0 ) );

		M_samples->addData( *this, data, false );
	}

    }
}
