#include "sample_data_bowner.h"

namespace soccer
{
    namespace formation
    {

        SampleDataBowner::SampleDataBowner()
            : bowner_( -1 ), index_changes_()
        {

        }

        // TODO Get all changes at a given index
        /*const std::vector<PlayerPosition>& SampleDataBowner::indexChanges(unsigned int index) const
        {
            // Check if index exists
            PlayerChanges::const_iterator it = index_changes_.find(index);

            // Invalid index
            assert (it == index_changes_.end () );

            return it->second;
        }*/

        // Check if player has changed in a given index

        /*const rcsc::Vector2D* SampleDataBowner::playerChanged(unsigned int index, unsigned int player_number ) const
        {
            const std::vector<IndexChange>& players_changed = indexChanges(index);

            for ( std::vector<IndexChange>::const_iterator it = players_changed.begin ();
                  it != players_changed.end ();
                  it++) {
                if ( it->unum_ == player_number ) {
                    return &(it->position_);
                }
            }
            return NULL;
        }*/

        unsigned int SampleDataBowner::numChanges( ) const
        {
            return index_changes_.size();
        }

        bool SampleDataBowner::read(std::istream& is)
        {
            std::string line_buf;

            //
            // Read ball owner number and number of other player samples
            //
            unsigned int num_indexes_changed;
            while ( std::getline( is, line_buf ) )
            {
                if ( line_buf.empty()
                     || line_buf[0] == '#'
                     || ! line_buf.compare( 0, 2, "//" ) )
                {
                    continue;
                }

                if ( std::sscanf( line_buf.c_str(), " Player %u %u", &this->bowner_, &num_indexes_changed ) != 2)
                {
                    std::cerr << " *** ERROR *** Illegal player with ball data segment. "
                              << '[' << line_buf << ']'
                              << std::endl;
                    return false;
                }

                break;
            }

            //
            // read new sample data.
            //

            for ( unsigned int s = 0 ; s < num_indexes_changed; s++)
            {
                if ( ! std::getline( is, line_buf ) )
                {
                    std::cerr << " *** ERROR *** failed to read description of changes to index data."
                              << " ball_owner=" << this->bowner_
                              << " num_indexes_changed=" << num_indexes_changed
                              << std::endl;
                    return false;
                }

                //
                // Read data about which index changed and the number of changes
                //
                SampleDataBowner::IndexChange index_change;
                unsigned int num_changes;
                if ( std::sscanf( line_buf.c_str(),
                                  " %u %u ",
                                  &index_change.index_, &num_changes ) != 2
                     // TODO Should verify after import if index changed is valid
                     // || !(index_changed <= dataCont().size())
                     )
                {
                    std::cerr << __FILE__ << ':' << __LINE__ << ':'
                              << " *** ERROR *** Illegal index change data."
                              << " ball_owner=" << this->bowner_
                              << " num_samples=" << num_indexes_changed
                              << " [" << line_buf << "]"
                              << std::endl;
                    return false;
                }

                //
                // Read all the changes made to the index
                //
                for ( unsigned int c = 0 ; c < num_changes ; c++ )
                {
                    if ( ! std::getline( is, line_buf ) )
                    {
                        std::cerr << " *** ERROR *** failed to read player data."
                                  << " ball_owner=" << this->bowner_
                                  << " num_samples=" << num_indexes_changed
                                  << " num_changes=" << num_changes
                                  << " change_index=" << c
                                  << std::endl;
                        return false;
                    }

                    //
                    // Read Player Data
                    //
                    SampleDataBowner::PlayerChange player_change;
                                        if ( std::sscanf( line_buf.c_str(),
                                      " %d %lf %lf ",
                                      &player_change.unum_, &player_change.position_.x, &player_change.position_.y ) != 3
                                      || !(player_change.unum_ >= 1 && player_change.unum_ <= 11 ))
                    {
                        std::cerr << __FILE__ << ':' << __LINE__ << ':'
                                  << " *** ERROR *** Illegal player data."
                                  << " ball_owner=" << this->bowner_
                                  << " num_samples=" << num_indexes_changed
                                  << " num_changes=" << num_changes
                                  << " change_index=" << c
                                  << " [" << line_buf << "]"
                                  << std::endl;
                        return false;
                    }
                    // Add player data to the samples container
                    index_change.changes_.push_back(player_change);
                }
                this->index_changes_.push_back(index_change);
            }

            return true;
        }

    }
}
