#ifndef FCPORTUGAL_STRATEGY_SETPLAY_CONFIG_H
#define FCPORTUGAL_STRATEGY_SEPTLAY_CONFIG_H

#include <strategy/options_config.h>

namespace soccer
{
    namespace strategy
    {

        class SetplayConfig
                : public OptionsConfig<SetplayConfig>
        {
            friend class Singleton<SetplayConfig>;
        public:
            // typedef { SINGLE_CHANNEL } CommunicationType;

            // Setplay configurations
            bool useSetplays() const;
            bool useCbr() const;
            bool writeCbrToFile() const;
            bool writeCbrToFileAfterExecution() const;
            double weightThisGame() const;
            double weightThisTeam() const;
            double weightOtherTeams() const;
            const std::string& cbrFilePrefix() const;

            bool useCommunication() const;
            bool singleChannelCommunication() const;
            unsigned int messageRepeatTime() const;

            const std::string& setplaysDir() const;
            const std::vector<std::string>& setplaysFiles() const;

            void print(std::ostream& os) const;
        private:
            SetplayConfig();

            static const bool USE_SETPLAYS;
            static const std::string SETPLAYS_DIR;

            static const std::string CBR_FILE_PREFIX; // prefix of cbr files: player number and '.conf'
            static const bool USE_CBR;
            static const bool WRITE_CBR_TO_FILE;
            static const bool WRITE_CBR_TO_FILE_AFTER_EXECUTION;
            static const double WEIGHT_THIS_GAME;
            static const double WEIGHT_THIS_TEAM;
            static const double WEIGHT_OTHER_TEAMS;

            bool M_use_setplays;
            std::string M_setplays_dir;
            std::vector<std::string> M_setplays_files;

            std::string M_cbr_file_prefix; // prefix of cbr files: player number and '.conf'
            bool M_use_cbr;
            bool M_write_cbr_to_file;
            bool M_write_cbr_to_file_after_execution;
            double M_weight_this_game;
            double M_weight_this_team;
            double M_weight_other_teams;
            bool M_use_communication;
            bool M_single_channel_communication;
            unsigned int M_message_repeat_time;
        };

    }
}
#endif // FCPORTUGAL_STRATEGY_SEPTLAY_CONFIG_H
