#ifndef FCPORTUGAL_STRATEGY_CONFIG_H
#define FCPORTUGAL_STRATEGY_CONFIG_H

#include <strategy/options_config.h>

namespace soccer
{
    namespace strategy
    {

        class StrategyConfig
                : public OptionsConfig<StrategyConfig>
        {
            friend class Singleton<StrategyConfig>;
        public:
            // Strategy configurations
            bool useDPRE() const;
            bool useSBSP() const;

            const std::string& leagueConfigFile();
            const std::string& setplaysConfigFile();
            const std::string& tacticsConfigFile();
            const std::string& formationsConfigFile();
            const std::string& fluxesConfigFile();
            const std::string& playerTypesConfigFile();

            void print(std::ostream& os) const;
        private:
            StrategyConfig();

            static const bool USE_DPRE;
            static const bool USE_SBSP;
            static const std::string LEAGUE_CONFIG_FILE;
            static const std::string SETPLAYS_CONFIG_FILE;
            static const std::string FORMATIONS_CONFIG_FILE;
            static const std::string TACTICS_CONFIG_FILE;
            static const std::string FLUXES_CONFIG_FILE;
            static const std::string PLAYER_TYPES_CONFIG_FILE;

            bool M_use_dpre;
            bool M_use_sbsp;

            std::string M_league_config_file;
            std::string M_setplays_config_file;
            std::string M_tactics_config_file;
            std::string M_formations_config_file;
            std::string M_fluxes_config_file;
            std::string M_player_types_config_file;
        };

    }
}

#endif //  FCPORTUGAL_STRATEGY_CONFIG_H
