#include "tactic.h"

#include <strategy/util.h>

using namespace soccer::strategy;

#include <iostream>
#include <sstream>

namespace soccer
{

    namespace tactic
    {
        Tactic::Tactic()
        {

        }

        unsigned int Tactic::id() const
        {
            return M_id;
        }

        unsigned int Tactic::defaultFormation() const
        {
            return M_default_formation;
        }

        unsigned int Tactic::flux() const
        {
            return M_flux;
        }

        unsigned int Tactic::setplaysSet() const
        {
            return M_setplays_set;
        }

        unsigned int Tactic::numFormations() const
        {
            return 1;
        }

        double Tactic::weightFlux() const
        {
            return M_weight_flux;
        }

        double Tactic::weightSafety() const
        {
            return M_weight_safety;
        }

        double Tactic::weightEasy() const
        {
            return M_weight_easy;
        }

        double Tactic::weightPass() const
        {
            return M_weight_pass;
        }

        double Tactic::weightDribble() const
        {
            return M_weight_dribble;
        }


        bool Tactic::usesGameSituations() const {
            return false;
        }

        bool Tactic::read(std::istream& is) {
            std::istringstream istr(util::getNextLine(is));
            // 1st line
            istr >> M_id;

            // 2nd line
            istr.clear();
            istr.str(util::getNextLine(is));
            istr >> M_default_formation;
            istr >> M_flux;
            istr >> M_setplays_set;
            istr >> M_weight_flux;
            istr >> M_weight_safety;
            istr >> M_weight_easy;
            istr >> M_weight_pass;
            istr >> M_weight_dribble;

            return true;
        }

    }
}


