#ifndef TACTIC_SELECTOR_H
#define TACTIC_SELECTOR_H

#include <soccer/iworld_model.h>

namespace soccer {

namespace tactic {

class ITacticSelector
{
public:
    virtual ~ITacticSelector() { }

    /*!
      \brief Decide the best tactic based on the current world state
      \return A pointer to the best tactic for the current game state or NULL otherwise
      */
    virtual unsigned int getTactic( const IWorldModel* world_model ) const = 0;
};

}
}

#endif // TACTIC_SELECTOR_H
