#ifndef FCPORTUGAL_TACTIC_WITH_SITUATIONS_H
#define FCPORTUGAL_TACTIC_WITH_SITUATIONS_H

#include <map>

#include <strategy/tactic/tactic.h>
#include <soccer/game_situation.h>

namespace soccer
{
    namespace tactic
    {
        class TacticWithSituations
                : public Tactic
        {
        public:
            typedef std::map<soccer::GameSituation, unsigned int> GameSituationFormations;

            TacticWithSituations();

            bool usesGameSituations() const;
            unsigned int formation(soccer::GameSituation game_situation) const;
            virtual unsigned int numFormations() const;
            const GameSituationFormations& gameSituationFormations() const;

            // Implementation of pure virtual methods
            Type type() const;

            virtual bool read(std::istream& is);
        private:
            GameSituationFormations M_formations;
            unsigned int M_default_formation;
        };
    }
}

#endif // FCPORTUGAL_TACTIC_WITH_SITUATIONS_H
